package cliente;

import interfaces.Perfil;
import java.io.*;
import java.net.*;
import java.util.logging.Level;
import java.util.logging.Logger;


public class Cliente{

    private Socket s;
    private BufferedReader in;
    private PrintWriter out;
    private ObjectInputStream inObj;
    private ObjectOutputStream outObj;

   public Cliente(String server, int port)
   {
        try {
            s = new Socket(server, port);
            in = new BufferedReader(new InputStreamReader(s.getInputStream()));
            out = new PrintWriter(s.getOutputStream(), true);
            outObj = new ObjectOutputStream(s.getOutputStream());
            inObj = new ObjectInputStream(s.getInputStream());
            
        } catch (UnknownHostException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
        }

   }


   public boolean login(String u, String p){
        try {
            out.println(u);
            out.println(p);
            out.flush();

            if (in.readLine().contains("OK")) {
                System.out.println("Autentificado!");
                this.iniciar();
                return true;
            } else {
                return false;
            }
        } catch (IOException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
   }

   public boolean enviarSolicitud(int id, boolean type){
       interfaces.Solicitud req = new interfaces.Solicitud(id, type);
        try {
            System.out.println("Voy a enviar la solicitud");
            outObj.writeObject(req);
            outObj.flush();
            System.out.println("Solicitud enviada");
        } catch (IOException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
        }

       return true;
   }

   public boolean actualizarPerfil(Perfil p){
        try {
            System.out.println("Voy a enviar el perfil");
            outObj.writeObject(p);
            outObj.flush();
            System.out.println("Perfil enviado");
        } catch (IOException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
        }

       return true;
   }

   public void iniciar(){
         //Thread tIn = new ThreadIn(inObj, outObj);
         Thread tOut = new ThreadPoll(inObj, outObj);
         //tIn.start();
         tOut.start();
         
   }

   public void cerrar(){
        try {
            outObj.writeObject("logout");
            outObj.close();
            inObj.close();
            in.close();
            out.close();
            s.close();
        } catch (IOException ex) {
            Logger.getLogger(Cliente.class.getName()).log(Level.SEVERE, null, ex);
        }
   }
}